import { ModuleWithProviders } from '@angular/core';
import { AudioProvider, CordovaMediaProvider, WebAudioProvider } from './ionic-audio-providers';
export declare class IonicAudioModule {
    /**
     * Configures Ionic Audio to use either Cordova or HTML5 audio.
     * If no ```audioProvider``` is set it will automatically choose one based on the current environment
     */
    static forRoot(audioProvider?: {
        provide: typeof AudioProvider;
        useFactory: () => CordovaMediaProvider | WebAudioProvider;
    }): ModuleWithProviders;
}
